{-|

Module      : AesonUtil

Description : My configuration for deriving instances for Data.Aeson

Copyright   : © 2015 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : non-portable (GHC, POSIX)

-}

module AesonUtil where

import Data.Aeson.TH
import qualified Data.Aeson.Parser as JP
import qualified Data.Aeson.Types as JT
import qualified Data.Attoparsec.ByteString as AP
import qualified Data.ByteString.UTF8 as BSU

import Data.Char

myJSONOpts = defaultOptions {
  sumEncoding = ObjectWithSingleField,
  fieldLabelModifier = firstToLower
  }

firstToLower [] = []
firstToLower (x:xs) = toLower x : xs

-- | Parse a 'String' into a JSON value.  It can be a leaf item
-- rather than a proper JSON document, which has to be an object
-- or an array.
stringToJSONValue :: String -> Either String JT.Value
stringToJSONValue s = AP.parseOnly JP.value (BSU.fromString s)
