{-# LANGUAGE FlexibleInstances, ParallelListComp #-}

{-|

Module: DBStorable

Description: Class for types that can be stored in a database

Copyright: &#xA9; 2015 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : POSIX

I like to use objects like this
@
data TableNames = Address | PhoneNumber ...
@
for the names of tables.

-}


module DBStorable (
  DBStorable(..)
  ) where

import Database

dbStorable_vcid :: String
dbStorable_vcid = "$Id: DBStorable.hs,v 5a02784b68c3 2017-01-19 18:10:41Z garrett $"

class DBStorable t where

  dbStore :: (Show tableName, Ord tableName) => 
             t -- ^ the object
             -> String -- ^ key under which to store it
             -> tableName -- ^ name of the table
             -> DBMonad tableName ()
  
  dbLoad :: (Show tableName, Ord tableName) => 
             String -- ^ key to load
             -> tableName -- ^ tabel to look in
             -> DBMonad tableName t
