{-# LANGUAGE RecordWildCards, NamedFieldPuns, DeriveDataTypeable, DeriveGeneric, TemplateHaskell #-}

module ReportFormatTypes where

import GHC.Generics

import Data.Data
import Data.Aeson.TH
import Data.Typeable

import System.IO

import AesonUtil

reportTypes_vcid :: String
reportTypes_vcid = "$Id: ReportFormatTypes.hs,v 5a02784b68c3 2017-01-19 18:10:41Z garrett $"


-- | Ways of writing out information
data OutputFormat =
  JSONOutput
  | YAMLOutput
  | PlainTextOutput
  | MarkdownOutput
  | GraphMLOutput
    deriving (Read, Show, Typeable, Data, Generic)

$(deriveJSON myJSONOpts ''OutputFormat)

-- | Where to send the output
data OutputDestination =
  AllToStdout
  | ToFilePerAgentId Bool FilePath
    -- ^ must include %d for where to put the agent's identifier
  | ToByteString
    deriving (Read, Show, Typeable, Data, Generic)

$(deriveJSON myJSONOpts ''OutputDestination)


