#include "BitFiddle.h"

#include <stdio.h>
#include <string.h>

const char bitFiddle_vcid[] = "$Id: BitFiddle.c,v 1607c537d3ac 2017-01-19 18:10:07Z garrett $";

void unpack_w32(uint32_t w, uint8_t *b)
{
  memset(b, 0, 32);

  asm (
"bt $0, %[w]\n"
"adc $0, 0(%[b])\n"
"bt $1, %[w]\n"
"adc $0, 1(%[b])\n"
"bt $2, %[w]\n"
"adc $0, 2(%[b])\n"
"bt $3, %[w]\n"
"adc $0, 3(%[b])\n"
"bt $4, %[w]\n"
"adc $0, 4(%[b])\n"
"bt $5, %[w]\n"
"adc $0, 5(%[b])\n"
"bt $6, %[w]\n"
"adc $0, 6(%[b])\n"
"bt $7, %[w]\n"
"adc $0, 7(%[b])\n"
"bt $8, %[w]\n"
"adc $0, 8(%[b])\n"
"bt $9, %[w]\n"
"adc $0, 9(%[b])\n"
"bt $10, %[w]\n"
"adc $0, 10(%[b])\n"
"bt $11, %[w]\n"
"adc $0, 11(%[b])\n"
"bt $12, %[w]\n"
"adc $0, 12(%[b])\n"
"bt $13, %[w]\n"
"adc $0, 13(%[b])\n"
"bt $14, %[w]\n"
"adc $0, 14(%[b])\n"
"bt $15, %[w]\n"
"adc $0, 15(%[b])\n"
"bt $16, %[w]\n"
"adc $0, 16(%[b])\n"
"bt $17, %[w]\n"
"adc $0, 17(%[b])\n"
"bt $18, %[w]\n"
"adc $0, 18(%[b])\n"
"bt $19, %[w]\n"
"adc $0, 19(%[b])\n"
"bt $20, %[w]\n"
"adc $0, 20(%[b])\n"
"bt $21, %[w]\n"
"adc $0, 21(%[b])\n"
"bt $22, %[w]\n"
"adc $0, 22(%[b])\n"
"bt $23, %[w]\n"
"adc $0, 23(%[b])\n"
"bt $24, %[w]\n"
"adc $0, 24(%[b])\n"
"bt $25, %[w]\n"
"adc $0, 25(%[b])\n"
"bt $26, %[w]\n"
"adc $0, 26(%[b])\n"
"bt $27, %[w]\n"
"adc $0, 27(%[b])\n"
"bt $28, %[w]\n"
"adc $0, 28(%[b])\n"
"bt $29, %[w]\n"
"adc $0, 29(%[b])\n"
"bt $30, %[w]\n"
"adc $0, 30(%[b])\n"
"bt $31, %[w]\n"
"adc $0, 31(%[b])\n"
       : /* no output registers */
       : [w] "a"(w), [b] "b"(b) /* w in eax, b in ebx */
       : /* clobbered */
       );
}

void
unpack_w32_array(unsigned int nWords, const uint32_t * const aBegin, uint8_t * const rBegin)
{
  // uint8_t * const rEnd = rBegin + 32 * nWords;
  const uint32_t * aEnd = aBegin + nWords;

  const uint32_t * p = aBegin;
  uint8_t * q = rBegin;

  /* clear result vector */
  memset(rBegin, 0, 32*nWords);

  /* unpack words */
  for(; p < aEnd; p++, q += 32)
    {
  asm (
"bt $0, %[w]\n"
"adc $0, 0(%[b])\n"
"bt $1, %[w]\n"
"adc $0, 1(%[b])\n"
"bt $2, %[w]\n"
"adc $0, 2(%[b])\n"
"bt $3, %[w]\n"
"adc $0, 3(%[b])\n"
"bt $4, %[w]\n"
"adc $0, 4(%[b])\n"
"bt $5, %[w]\n"
"adc $0, 5(%[b])\n"
"bt $6, %[w]\n"
"adc $0, 6(%[b])\n"
"bt $7, %[w]\n"
"adc $0, 7(%[b])\n"
"bt $8, %[w]\n"
"adc $0, 8(%[b])\n"
"bt $9, %[w]\n"
"adc $0, 9(%[b])\n"
"bt $10, %[w]\n"
"adc $0, 10(%[b])\n"
"bt $11, %[w]\n"
"adc $0, 11(%[b])\n"
"bt $12, %[w]\n"
"adc $0, 12(%[b])\n"
"bt $13, %[w]\n"
"adc $0, 13(%[b])\n"
"bt $14, %[w]\n"
"adc $0, 14(%[b])\n"
"bt $15, %[w]\n"
"adc $0, 15(%[b])\n"
"bt $16, %[w]\n"
"adc $0, 16(%[b])\n"
"bt $17, %[w]\n"
"adc $0, 17(%[b])\n"
"bt $18, %[w]\n"
"adc $0, 18(%[b])\n"
"bt $19, %[w]\n"
"adc $0, 19(%[b])\n"
"bt $20, %[w]\n"
"adc $0, 20(%[b])\n"
"bt $21, %[w]\n"
"adc $0, 21(%[b])\n"
"bt $22, %[w]\n"
"adc $0, 22(%[b])\n"
"bt $23, %[w]\n"
"adc $0, 23(%[b])\n"
"bt $24, %[w]\n"
"adc $0, 24(%[b])\n"
"bt $25, %[w]\n"
"adc $0, 25(%[b])\n"
"bt $26, %[w]\n"
"adc $0, 26(%[b])\n"
"bt $27, %[w]\n"
"adc $0, 27(%[b])\n"
"bt $28, %[w]\n"
"adc $0, 28(%[b])\n"
"bt $29, %[w]\n"
"adc $0, 29(%[b])\n"
"bt $30, %[w]\n"
"adc $0, 30(%[b])\n"
"bt $31, %[w]\n"
"adc $0, 31(%[b])\n"
       : /* no output registers */
       : [w] "a"(*p), [b] "b"(q)
       : /* clobbered */
       );
   }


}

uint32_t
get_bits_as_word(const uint32_t * const aBegin, unsigned int nBegin, unsigned int nEnd )
{
  unsigned int
    beginWdIx = nBegin / 32,
    // beginBtIx = nBegin % 32,
    endWdIx = nEnd / 32,
    endBtIx = nEnd % 32,
    nBits = nEnd - nBegin;

  uint32_t loWd = aBegin[beginWdIx];

  /* Requested bit span is within one word */
  if(endWdIx == beginWdIx && endBtIx > 0)
    {
      return (loWd << (32 - endBtIx)) >> (32 - nBits);
    }
  else
    {
      uint32_t hiWd = aBegin[beginWdIx + 1];
      uint64_t dWd = ((uint64_t) loWd) | ((uint64_t) hiWd << 32);
      return (uint32_t) ((dWd << (32 - endBtIx)) >> (64 - nBits));
    }
}

/*
 * Do majority of 2k+1 decoding from bits in source from
 * source[beginWdIx;beginBtIx] up to not but including
 * [endWdIx;endBtIx] and store the result in dest.  This function
 * assumes the input parameters are well formed, and that there's
 * at least one output bit to be had.
 *
 * (Notation here: a[w;b] means bit b of a[w].)
 */

void majority_decode(const unsigned int k,
                     const uint32_t * const source,
                     unsigned int beginWdIx,
                     unsigned int beginBtIx,
                     unsigned int endWdIx,
                     unsigned int endBtIx,
                     uint32_t * dest)
{
  const uint32_t * endP = source + endWdIx;

  /* If endBtIx == 0, then there is no word at *endP because the
     bit string ends just before the beginning of where *endP
     would be. In that case, re-represent the end as bit index 32
     of the last word. That way, *endP is always the last word
     actually read, which is a bit different from how iterator
     ends usually work, but I can't find a cleaner way to do
     this. */
  if(endBtIx == 0)
    {
      endP--;
      endBtIx = 32;
    }

  /* where the current word was read from */
  const uint32_t * readP = source + beginWdIx;

  /* whre the next word will be written to */
  uint32_t * writeP = dest;

  /* Storage for up to 32 input bits */
  uint32_t readBuffer = (*readP) >> beginBtIx;

  /* How many bits are left in readBuffer */
  unsigned int readBitsLeft = 32 - beginBtIx;

  /* Storage for 32 decoded bits */
  uint32_t writeBuffer = 0;

  /* Where in writeBuffer the next bit will be written */
  unsigned int writeBtIx = 0;

  uint32_t b = 0;

  unsigned int upCount = 0;
  const unsigned int blockBitsLeftInit = 2*k+1;
  unsigned int blockBitsLeft = blockBitsLeftInit;

  // printf("k: %d\n", k);
  // printf("beginWdIx: %d, beginBtIx: %d\n", beginWdIx, beginBtIx);
  // printf("endWdIx: %d, endBitIx: %d\n", endWdIx, endBtIx);

  // const uint32_t * p;
  // for(p = readP; p < endP; p++)
  //  {
  //    printf("%08xd\n", *p);
  //  }

 loadBit:
  /* load next bit into b */
  /* first the easy case */
  if(readBitsLeft > 0)
    {
      b = readBuffer & 0x1;
      readBuffer >>= 1;
      readBitsLeft--;
    }
  /* else have to load a new word */
  else if(readP < endP)
    {
      readP++;
      readBuffer = *readP;
      /* If what we just read isn't the last word, it's a whole
         word */
      if(readP <= endP)
        {
          readBitsLeft = 32;
        }
      /* otherwise we just read the last word and the bit string
         in question may be only part of the word */
      else
        {
          readBitsLeft = endBtIx;
        }
      goto loadBit;
    }
  else
    /* no more bits, write what we have and be done */
    goto done;

  /* end of load bit */
  // printf("b = %d\n", b);

  /* count the bit in b */
  if(b)
    {
      upCount++;
    }
  blockBitsLeft--;

  /* If we've seen less than 2k+1 bits */
  if(blockBitsLeft > 0)
    goto loadBit;

  /* else we've seen all 2k+1, write the 1 or leave it 0 */
  // printf("upCount = %d\n", upCount);

  if(upCount > k)
    {
      writeBuffer |= 1 << writeBtIx;
    }

  // printf("writeBuffer = %x\n", writeBuffer);

  upCount = 0;
  blockBitsLeft = blockBitsLeftInit;
  writeBtIx++;

  /* If the write buffer is not full, go read another bit */
  if(writeBtIx < 32)
    goto loadBit;

  // writeWord:

  /* else we have to write this word and start a new one */
  *writeP = writeBuffer;
  writeP++;
  writeBuffer = 0;
  writeBtIx = 0;

  goto loadBit;

 done:
  /* If the write buffer is not empty, have to write it */
  if(writeBtIx > 0)
    {
      *writeP = writeBuffer;
    }

  return;

}

#if defined(BIT_FIDDLE_MAIN)

void
print_bits(uint32_t w)
{
  uint8_t b[32];
  int i;

  unpack_w32(w, b);

  for(i = 0; i < 32; i++)
    {
      printf("%2d: %d\n", i, b[i]);
    }
}

int
main(int argc, char** argv)
{
  uint32_t w = ~0x87654321;
  uint32_t gb[] = { w, ~w };
  uint32_t cb[] = { 0 };

  print_bits(gb[0]);
  print_bits(gb[1]);


  majority_decode(1, gb, 0, 2, 1, 30, cb);

  print_bits(cb[0]);

}

#endif
