#if !defined(BIT_FIDDLE_H)
#define BIT_FIDDLE_H

#include <stdint.h>

void
unpack_w32(uint32_t w, uint8_t *b);

void
unpack_w32_array(unsigned int nWords, const uint32_t * const aBegin, uint8_t * const rBegin);

// I thought get_bits_as_word might speed up wbGetBitsAsWord, but
// the function call overhead offsets any speed improvements.
// Apparently GHC is better than I thought at optimizing bit
// fiddling. So this is here, just disappointing:

uint32_t
get_bits_as_word(const uint32_t * const aBegin, unsigned int bitBegin, unsigned int nBits);

/*
 * Do majority of 2k+1 decoding from bits in source from
 * source[beginWdIx;beginBtIx] up to not but including
 * [endWdIx;endBtIx] and store the result in dest.  This function
 * assumes the input parameters are well formed, and that there's
 * at least one output bit to be had.
 *
 * (Notation here: a[w;b] means bit b of a[w].)
 */

void majority_decode(const unsigned int k,
                     const uint32_t * const source,
                     unsigned int beginWdIx,
                     unsigned int beginBtIx,
                     unsigned int endWdIx,
                     unsigned int endBtIx,
                     uint32_t * dest);


#endif
