module BitUtil where

import Data.Bits
import Numeric

bitUtil_vcid :: String
bitUtil_vcid = "$Id: BitUtil.hs,v 1607c537d3ac 2017-01-19 18:10:07Z garrett $"

-- | Take a list of indices and returns an 'Int' where exactly
-- those bits are set.

fromBitIndices :: (Num t, Bits t) => [Int] -> t
fromBitIndices [] = 0
fromBitIndices (n:ns) = bit n .|. fromBitIndices ns

-- | Turn a list of bits back into a 'Bits'-instance object

fromBits :: (Num t, Bits t) => [Bool] -> t
fromBits [] = 0
fromBits (b:bs) = (if b then 1 else 0) .|. shiftL (fromBits bs) 1

-- | Produce a number of bits from an 'Integer' or other 'Bits'
-- instance

toBits :: Bits t => Int -> t -> [Bool]
toBits nBits n = map (testBit n) [0..nBits - 1]

showAsHex :: [Bool] -> String
showAsHex bits =
  let n :: Integer
      n = fromBits bits
  in showHex n ""

showAs01s :: [Bool] -> [Char]
showAs01s bs =
  map (\b -> if b then '1' else '0') bs
