{-# LANGUAGE FlexibleInstances, FlexibleContexts, UndecidableInstances, OverlappingInstances #-}

module ShortShow where

import Text.Printf
import Data.List

shortShow_vcid :: String
shortShow_vcid = "$Id: ShortShow.hs,v d8e4380c1184 2017-01-19 18:11:01Z garrett $"

class Show t => ShortShow t where

  shortShow :: t -> String

  shortShow = show


instance ShortShow Int

instance ShortShow Double where
  shortShow x = printf "%.2f"
  
instance ShortShow String where
  shortShow x =
    if length x <= 10
    then show x
    else
      printf "\"%10s\"" x

instance ShortShow t => ShortShow [t] where
  shortShow xs =
      "["
      ++ intercalate "," (map shortShow (take 10 xs))
      ++ (if length xs <= 10
          then "]"
          else ",...]")

instance (ShortShow t1, ShortShow t2) => ShortShow (t1, t2) where
  shortShow (x1, x2) =
    concat ["(", shortShow x1, ",", shortShow x2, ")"]
